=== debian/changelog ===
mariadb-connector-c (1:3.0.6-1build1) cosmic; urgency=high

  * No change rebuild against openssl 1.1.1 with TLS 1.3 support.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 29 Sep 2018 01:36:52 +0100

mariadb-connector-c (1:3.0.6-1) unstable; urgency=low

  * New upstream version 3.0.6 (Closes: #877622)
  * Use versioned in installation path to avoid conflicts (Closes: #902729)
  * Change upstream signing key format to armored ASCII
  * Add rudimentary autopkgtest

 -- Otto Kekäläinen <otto@debian.org>  Sun, 05 Aug 2018 00:02:45 +0800

mariadb-connector-c (1:3.0.3-2) unstable; urgency=medium

  [ Pirate Praveen ]
  * Add epoch to fix "mariadb-connector-c: ships libmariadb3 version 3.0.3-1,
    which is lower than the one in mariadb-10.[23]" (Closes: #888095)

  [ Otto Kekäläinen ]
  * Add upstream signing key
  * Replace all instances of Priority: extra with Priority: optional
  * Use secure https in all urls

 -- Otto Kekäläinen <otto@debian.org>  Sun, 24 Jun 2018 22:18:30 +0300
