=== debian/tests/control ===
Tests: smoke
Depends: libmariadb-dev
Restrictions: allow-stderr
