## mariadb-connector-c 3.0.7

=== debian/changelog ===
mariadb-connector-c (1:3.0.7-2) unstable; urgency=low

  * Add libssl-dev and zlib1g-dev as libmariadb-dev depends (Closes: #909181)
  * Add curl as dependency so remote_io module builds
  * Make libmariadb3 install list explicit on included connector plugins
  * Update gitlab-ci.yml to latest revision from Salsa-CI team
  * Extend libmariadb-dev with libmariadb.pc config

 -- Otto Kekäläinen <otto@debian.org>  Wed, 12 Dec 2018 11:32:06 +0200

mariadb-connector-c (1:3.0.7-1) unstable; urgency=low

  * New upstream version 3.0.7
  * Fix CMake flag so socket path becomes again correct (Closes: #911880)
  * Update Debian starndars version to 4.2.1
  * Gitlab-CI: Remove privileged tags as not needed anymore

 -- Otto Kekäläinen <otto@debian.org>  Sat, 01 Dec 2018 19:37:44 +0200
