=== debian/control ===
--- 
+++ 
@@ -1,20 +1,41 @@
 Source: mariadb-connector-c
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
+Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Daniel Schepler <schepler@debian.org>,
            Otto Kekäläinen <otto@debian.org>
-Build-Depends: cmake (>= 2.8.8), debhelper (>= 11), libssl-dev, zlib1g-dev
-Standards-Version: 4.1.4
+Build-Depends: cmake (>= 2.8.8),
+               debhelper (>= 11),
+               dh-exec,
+               libcurl4-openssl-dev,
+               libssl-dev,
+               zlib1g-dev
+Standards-Version: 4.2.1
 Section: libs
 Homepage: https://mariadb.org/
 Vcs-Browser: https://salsa.debian.org/mariadb-team/mariadb-connector-c
 Vcs-Git: https://salsa.debian.org/mariadb-team/mariadb-connector-c.git
 
+Package: libmariadb3
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
+Multi-Arch: same
+Description: MariaDB Connector/C
+ MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
+ server. SQL (Structured Query Language) is the most popular database query
+ language in the world. The main goals of MariaDB are speed, robustness and
+ ease of use.
+ .
+ This package includes MariaDB Connector/C.
+
 Package: libmariadb-dev
 Section: libdevel
 Architecture: any
-Depends: libmariadb3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libmariadb3 (= ${binary:Version}),
+         libssl-dev,
+         zlib1g-dev,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Provides: libmariadb-client-lgpl-dev
 Conflicts: libmariadb-client-lgpl-dev
 Replaces: libmariadb-client-lgpl-dev
@@ -32,23 +53,12 @@
  differences in licensing: this package uses the LGPL, while
  libmariadbclient-dev uses the GPL.
 
-Package: libmariadb3
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Multi-Arch: same
-Description: MariaDB Connector/C
- MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
- server. SQL (Structured Query Language) is the most popular database query
- language in the world. The main goals of MariaDB are speed, robustness and
- ease of use.
- .
- This package includes MariaDB Connector/C.
-
 Package: libmariadb-dev-compat
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libmariadb-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libmariadb-dev (= ${binary:Version}),
+         ${misc:Depends}
 Conflicts: libmariadb-client-lgpl-dev-compat,
            libmariadbclient-dev,
            libmariadbclient-dev-compat,
