=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 	-DPLUGINDIR_DEB=mariadb3 \
 	-DWITH_MYSQLCOMPAT=ON \
 	-DWITH_EXTERNAL_ZLIB:BOOL=ON \
-	-DMYSQL_UNIX_ADDR:STRING=/var/run/mysqld/mysqld.sock
+	-DMARIADB_UNIX_ADDR:STRING=/var/run/mysqld/mysqld.sock
 
 override_dh_makeshlibs:
 	dh_makeshlibs -X/mariadb3/plugin/
